mod Ex07a logic: 'cl'

incl Mtex

incl Mtexg

loc rem 
  \para \bf  7. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end streda 26.3.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parovacej funkcii 
  a zoznamom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicq  \end in the file \it  
  mlogicq.cl  \end contains the syntax of quantifier tableau rules. The module 
  \it  Mlogicd  \end in the file \it  mlogicd.cl  \end contains the syntax of 
  derived tableau rules. The module \it  Mlogicpa  \end in the file \it  
  mlogicpa.cl  \end contains the syntax of arithmetic tableau rules and built-in 
  properties of the pre-defined functions and predicates in the system CL. 

rem 
  \para \bf  Chapter.  \end \bf  Recursive Bootstrapping of PA.  \end 

rem 
  \para \bf  Section. Suitable Pairing Function.  \end 

rem 
  \para \bf  [CL] Pairing function.  \end The following properties of the 
  Catalan pairing function are built in into the CL theorem prover: 
  \eq* 
    x1,x2 = y1,y2 <-> x1 = y1 & x2 = y2
  \end
  \eq* 
    x,y = 0 <-> \f
  \end
  \para Moreover, we have 
  \eq (occur_check)
    x = Tex2_bappl1(Tex0_tau,x) <-> \f
  \end
  \para for terms \ft Tex2_bappl1(Tex0_tau,x) \end of the form 
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),x,y)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y,x)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(x,y1),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(y1,x),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,x,y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,y2,x)
  \end
  \eq* 
    Tex0_dotsc
  \end

rem 
  \para \bf  [CL] Pair case analysis.  \end Syntax: 
  \eq* 
    'case P ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(P,x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(x,0),
                                              Tex_f1_g_x_assum Tex_f2_g_eq(x,v,w)))
         \end
         \para where \ft v \end and \ft w \end are new variables \it  
         (eigen-variables)  \end. 
  \end
  \para The predicate \ft P \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  [CL] Pair induction.  \end Syntax: 
  \eq* 
    'ind P ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(P,x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex2_bappl1(Tex0_phi,
                                                                                                    v),
                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                    w)),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       v,
                                                                                       w))))
         \end
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(P,x),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    v)),
                                                                                        Tex_f2_g_forall(a,
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    w))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       v,
                                                                                       w))))
         \end
  \end
  \para The predicate \ft P \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  [CL] Pair size.  \end The pair size function \ft |x| \end is 
  defined in the module \it  Standard  \end. The following its properties are 
  built in into the CL theorem prover: 
  \eq* 
    |0| = 0
  \end
  \eq* 
    |v,w| = |v|+|w|+1
  \end
  \eq* 
    |x| = 0 <-> x = 0
  \end
  \eq* 
    |x| = 1 <-> x = 0,0
  \end
  \eq* 
    |x++y| = |x|+|y|
  \end

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(0) = 0
  Reflect(v,w) = Reflect(w),Reflect(v)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Reflect(x) = 0 <-> x = 0
  \end
  \eq* 
    |Reflect(x)| = |x|
  \end
  \eq* 
    Reflect Reflect(x) = x
  \end
  \eq* 
    Reflect(x) = Reflect(y) -> x = y
  \end
  \eq* 
    \e y Reflect(y) = x
  \end

thm Reflect_is_zero
  Reflect(x) = 0 <-> x = 0

thm Reflect_szp
  |Reflect(x)| = |x|

thm Reflect_reflect
  Reflect Reflect(x) = x

thm Reflect_injective
  Reflect(x) = Reflect(y) -> x = y

thm Reflect_surjective
  \e y Reflect(y) = x

