mod Mauxb logic: 'cl'

incl Mtex

rem 
  \para \bf  Catalan pairing function.  \end 

rem 
  \para \it  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \it  Iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

thm Iproj2_zero
  Iproj2(n,0) = 0
proof 
 ind N; n @ 0; n
  proved
  proved..

thm Iproj2_comm
  Proj2 Iproj2(n,x) = Iproj2(n,Proj2(x))
proof 
 ind N; n @ 0; n
  proved
  proved..

